"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.settingsFactory = void 0;
var index_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/index");
var defaults_1 = require("./defaults");
var runtime_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/runtime");
var storageCS_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/storage/storageCS");
var pluggable_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/integrations/pluggable");
var pluggableLogger_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/logger/pluggableLogger");
var consent_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/consent");
var params = {
    defaults: defaults_1.defaults,
    acceptKey: true,
    runtime: runtime_1.validateRuntime,
    storage: storageCS_1.validateStorageCS,
    integrations: pluggable_1.validatePluggableIntegrations,
    logger: pluggableLogger_1.validateLogger,
    consent: consent_1.validateConsent,
};
function settingsFactory(config) {
    var settings = (0, index_1.settingsValidation)(config, params);
    return settings;
}
exports.settingsFactory = settingsFactory;
